	.ascii "YOOP01"
* get multipad status
* exit: d0 = 0 if multitap
	.globl get_multitap
get_multitap:
		move.b #0x43, 0xA1000B
		nop
		move.b #0x7C, 0xA10005
		nop
		move.b #0x7F, 0xA1000B
		nop
		move.b #0x7C, 0xA10005
		nop
		moveq #0, %d0
		move.b 0xA10003, %d0
		and.b #0x03, %d0
		rts

* get current pad value
* entry: a0 = pad control port
* exit:  d2 = pad value (- 0 s a 0 0 d u - 1 c b r l d u)
	.globl get_pad
get_pad:
	movea.l  4(%sp), %a0
	jsr 	get_pad_original
	lsl.w	#8,%d0
	or.w	%d1,%d0
	rts


***************************************************************
**
**  NHL94 dedicated code - start
**
***************************************************************
	.equ	multipadEnabled, 0xFFD046
	.equ	readMultiportA, 0x1A3B2
	.equ	readMultiportB, 0x1A3DC
	.equ	readMultiportC, 0x1A406
	.equ	readMultiportD, 0x1A430
	.equ	readSinglePortA, 0x1A470
	.equ	readSinglePortB, 0x1A464
	.equ	player1_io, 0xFFBEF6
	.equ	player2_io, 0xFFBEF7
	.equ	player3_io, 0xFFBEF8
	.equ	player4_io, 0xFFBEF9
	.equ	goalieP1P2, 0xFFBF06
	.equ	goalieP3P4, 0xFFBF08

	.section joy /* see md.ld for more info on 'joy' section */
* call this from 0x1A374
* if 0xFFBF06 & 0x0000, P1 mode
* if 0xFFBF06 & 0x4000, P2 mode
* if 0xFFBF06 & 0x8000, P3 mode
* if 0xFFBF06 & 0xC000, P4 mode
	.global readPad_w_flag
readPad_w_flag:
 	tst.w   multipadEnabled
	beq   	singlePad

	jsr   	readMultiportA
	move.b  %d0,player1_io

	lea		goalieP1P2,%a0
	bset.b	#6, (%a0)
	jsr   	readMultiportB
	move.b  %d0,player2_io

	lea		goalieP1P2,%a0
	bset.b	#7, (%a0)
	bclr.b	#6, (%a0)
	jsr   	readMultiportC
	move.b  %d0,player3_io

	lea		goalieP1P2,%a0
	bset.b	#7, (%a0)
	bset.b	#6, (%a0)
	jsr   	readMultiportD
	move.b  %d0,player4_io

	bra   	readEnd
singlePad:
	jsr   	readSinglePortA
	move.b  %d0,player1_io

	lea		goalieP1P2,%a0
	bset.b	#6, (%a0)
	jsr   	readSinglePortB
	move.b  %d0,player2_io

readEnd:
	lea		goalieP1P2,%a0
	bclr.b	#7, (%a0)
	bclr.b	#6, (%a0)
	lea		goalieP3P4,%a0
	bclr.b	#7, (%a0)
	bclr.b	#6, (%a0)
	rts

* get current pad value
* entry: a0 = pad control port
* exit:  d2 = pad value (0 0 0 1 M X Y Z S A C B R L D U) or (0 0 0 0 0 0 0 0 S A C B R L D U)
*
* call this code from 0x1A49A to handle 6 buttons
	.globl get_pad_clean
get_pad_clean:
		movem.l %d2,-(%sp)
        bsr   	get_input       /* - 0 s a 0 0 d u - 1 c b r l d u */
        move.w  %d0,%d1
        and.w  #0x0C00,%d0
        bne   	button3
        bsr   	get_input       /* - 0 s a 0 0 d u - 1 c b r l d u */
        bsr   	get_input       /* - 0 s a 0 0 0 0 - 1 c b m x y z */
        move.w  %d0,%d2
        bsr   	get_input       /* - 0 s a 1 1 1 1 - 1 c b r l d u */
        and.w  #0x0F00,%d0      /* 0 0 0 0 1 1 1 1 0 0 0 0 0 0 0 0 */
        cmp.w  #0x0F00,%d0
        beq   	button6          /* six button pad */
button3:
		move.w	%d1,%d0
		lsr.w	#8,%d0
		and.w	#0xFF,%d0		/* 0 0 0 0 0 0 0 0 - 0 s a 0 0 d u */
		and.w	#0xFF,%d1		/* 0 0 0 0 0 0 0 0 - 1 c b r l d u */
		movem.l (%sp)+,%d2
		rts
button6:
		btst	#1, %d2
		bne		button3
handleY:
		lea		goalieP1P2,%a0
		bclr.b	#7,(%a0)
		beq		handleYP1P2
handleYP3P4:
		bclr.b	#6,(%a0)
		lea		goalieP3P4,%a0
		beq		handleY1
*		beq		handleYP3
handleYP4:
		bra handleY2
*handleYP3:
*		bra handleY1


handleYP1P2:
		bclr.b	#6,(%a0)
		beq		handleYP1
handleYP2:
		bra handleY2
handleYP1:
*		bra handleY1

handleY1:
		move.w	(%a0),%d2
		and.w	#0x01FF,%d2
		move.w	%d2,(%a0)
		bra		adjustB

handleY2:
		move.w	(%a0),%d2
		and.w	#0xFF01,%d2
		move.w	%d2,(%a0)

adjustB:
		bclr	#4, %d1			/* force B button */
		bra		button3


* read single phase from controller
get_input:
        move.b  #0x00,(%a0)
        nop
        nop
        move.b  (%a0),%d0
        move.b  #0x40,(%a0)
        lsl.w   #8,%d0			/* lsl instruction avoid the nop*2 use */
        move.b  (%a0),%d0
        rts

***************************************************************
**
**  NHL94 dedicated code - end
**
***************************************************************

	.ascii "END_OF_CODE " /* easy to find pointer on binary file */

* get current pad value
* must be there to allow get_input bsr call (and not jsr)
* entry: a0 = pad control port
* exit:  d2 = pad value (0 0 0 1 M X Y Z S A C B R L D U) or (0 0 0 0 0 0 0 0 S A C B R L D U)
	.globl get_pad_original
get_pad_original:
        bsr   	get_input       /* - 0 s a 0 0 d u - 1 c b r l d u */
        move.w  %d0,%d1
        and.w  #0x0C00,%d0
        bne   	no_pad
        bsr   	get_input       /* - 0 s a 0 0 d u - 1 c b r l d u */
        bsr   	get_input       /* - 0 s a 0 0 0 0 - 1 c b m x y z */
        move.w  %d0,%d2
        bsr   	get_input       /* - 0 s a 1 1 1 1 - 1 c b r l d u */
        and.w  #0x0F00,%d0      /* 0 0 0 0 1 1 1 1 0 0 0 0 0 0 0 0 */
        cmp.w  #0x0F00,%d0
        beq   	common          /* six button pad */
        move.w  #0x010F,%d2      /* three button pad */
common:
        lsl.b	#4,%d2			/* - 0 s a 0 0 0 0 m x y z 0 0 0 0 */
        lsl.w   #4,%d2			/* 0 0 0 0 m x y z 0 0 0 0 0 0 0 0 */
        and.w  #0x303F,%d1		/* 0 0 s a 0 0 0 0 0 0 c b r l d u */
        move.b  %d1,%d2			/* 0 0 0 0 m x y z 0 0 c b r l d u */
        lsr.w   #6,%d1			/* 0 0 0 0 0 0 0 0 s a 0 0 0 0 0 0 */
        or.w    %d1,%d2			/* 0 0 0 0 m x y z s a c b r l d u */
        *eor.w  #0x1FFF,%d2		/* 0 0 0 1 M X Y Z S A C B R L D U */
        eor.w	#0x1000, %d2	/* 0 0 0 1 m x y z s a c b r l d u */
        move.w	%d2,%d0
        rts
no_pad:
        move.w  #0xF000,%d0
        rts
