#ifndef __INC_ANIM__
#define __INC_ANIM__


#define	ANIM_PIECE	00
#define ANIM_NEXT	01



struct str_Sprite{
	u16	Idx;
	u16	X,Y; // upon frame upper left
};

struct str_CBox{
	u16	X,Y; // upon frame upper left
	u16	Width;
	u16	Height;
};

struct str_Frame {
	u16	nbSprites;
	struct 	str_Sprite	*Sprites;
	u16	nbCBoxes;
	struct 	str_CBox		*CBoxes;
	u32		Timer;
	u16	Next;
	u32		Data;

//	CHAR	Name[256];
};

struct str_Anim {
	u16	Width, Height;
	u16	nbFrames;
	struct	str_Frame		**Frames;
	u16 	compressSize;
	u8 	sprite_width;
	u8 	sprite_height;
	u16 	nbTiles;
	u16	*sprite_data;
//	WORD	activeFrame;
};


#define	MAX_ANIMS	( 10 )
struct AnimatedSprite
{
	BOOL  	active;
	u8 	IDCode;
	u8	bhvIdx;
	u8 	curFrame;
	u8 	curTick;
	u16	x;
	u16	y;
	u8 	palIdx;
	u16 	idxTile;
	u8	flip;
	struct 	str_Anim	*AnimLib;
	u16	data;
}Anim[MAX_ANIMS];

extern 	struct AnimatedSprite	Anim[MAX_ANIMS];
extern	u8					Anim_sprNumber;

extern struct str_Anim pieces_anim;

void	Anim_Init( );
u16 	Anim_Load( struct str_Anim *AnimLib, u16 idxTile);
u8		Anim_New( u8 IdCode, struct str_Anim *AnimLib, u16 firstTile, u16 posX, u16 posY, u8 pal);
void 	Anim_Delete( u8 idxSpr );
void	Anim_Update( );
void	Anim_Update1( );
void	Anim_Update2( );
BOOL	Anim_JumpTo( u8 idxSpr, u8 toFrame);


#endif
